<?php

class ControllerPaymentCkassa extends Controller {

    private $error = array();

    public function index() {

        $this->load->language('payment/ckassa');
        $this->load->model('localisation/order_status');


        $this->document->setTitle($this->language->get('heading_title'));

        if ($this->request->server['REQUEST_METHOD'] == 'POST' && $this->validate()) {

            $this->load->model('setting/setting');
            $this->model_setting_setting->editSetting('ckassa', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_edit'] = $this->language->get('text_edit');

        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['tab_general'] = $this->language->get('tab_general');

        $data = array_merge($data, $this->prepareConfiguration());

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['ckassa_url'])) {
            $data['ckassa_url_error'] = $this->error['ckassa_url'];
        } else {
            $data['ckassa_url_error'] = '';
        }

        if (isset($this->error['ckassa_secret'])) {
            $data['ckassa_secret_error'] = $this->error['ckassa_secret'];
        } else {
            $data['ckassa_secret_error'] = '';
        }

        if (isset($this->error['ckassa_shop_key'])) {
            $data['ckassa_shop_key_error'] = $this->error['ckassa_shop_key'];
        } else {
            $data['ckassa_shop_key_error'] = '';
        }

        // label and option titles
        $data['entry_ckassa_status'] = $this->language->get('entry_ckassa_status');
        $data['entry_ckassa_invunic'] = $this->language->get('entry_ckassa_invunic');
        $data['entry_ckassa_invunic_simple'] = $this->language->get('entry_ckassa_invunic_simple');
        $data['entry_ckassa_invunic_created'] = $this->language->get('entry_ckassa_invunic_created');
        $data['entry_ckassa_invunic_none'] = $this->language->get('entry_ckassa_invunic_none');
        $data['entry_ckassa_is_test'] = $this->language->get('entry_ckassa_is_test');
        $data['entry_ckassa_url'] = $this->language->get('entry_ckassa_url');
        $data['entry_ckassa_cb_url'] = $this->language->get('entry_ckassa_cb_url');
        $data['entry_ckassa_success_url'] = $this->language->get('entry_ckassa_success_url');
        $data['entry_ckassa_fail_url'] = $this->language->get('entry_ckassa_fail_url');
        $data['entry_ckassa_secret'] = $this->language->get('entry_ckassa_secret');
        $data['entry_ckassa_shop_key'] = $this->language->get('entry_ckassa_shop_key');
        $data['entry_ckassa_currency'] = $this->language->get('entry_ckassa_currency');
        $data['entry_ckassa_lang'] = $this->language->get('entry_ckassa_lang');
        $data['entry_ckassa_country'] = $this->language->get('entry_ckassa_country');
        $data['entry_ckassa_taxation'] = $this->language->get('entry_ckassa_taxation');
        $data['entry_ckassa_tax'] = $this->language->get('entry_ckassa_tax');
        $data['entry_ckassa_tax_delivery'] = $this->language->get('entry_ckassa_tax_delivery');
        $data['entry_ckassa_payment_method'] = $this->language->get('entry_ckassa_payment_method');
        $data['entry_ckassa_payment_object'] = $this->language->get('entry_ckassa_payment_object');
        $data['entry_ckassa_sort_order'] = $this->language->get('entry_ckassa_sort_order');
        $data['entry_ckassa_tax_none'] = $this->language->get('entry_ckassa_tax_none');
        $data['entry_ckassa_tax_vat10'] = $this->language->get('entry_ckassa_tax_vat10');
        $data['entry_ckassa_tax_vat18'] = $this->language->get('entry_ckassa_tax_vat18');
        $data['entry_ckassa_tax_vat110'] = $this->language->get('entry_ckassa_tax_vat110');
        $data['entry_ckassa_tax_vat118'] = $this->language->get('entry_ckassa_tax_vat118');
        $data['entry_ckassa_tax_vat20'] = $this->language->get('entry_ckassa_tax_vat20');
        $data['entry_ckassa_tax_vat120'] = $this->language->get('entry_ckassa_tax_vat120');
        $data['entry_ckassa_payment_method_full_prepayment'] = $this->language->get('entry_ckassa_payment_method_full_prepayment');
        $data['entry_ckassa_payment_method_prepayment'] = $this->language->get('entry_ckassa_payment_method_prepayment');
        $data['entry_ckassa_payment_method_advance'] = $this->language->get('entry_ckassa_payment_method_advance');
        $data['entry_ckassa_payment_method_full_payment'] = $this->language->get('entry_ckassa_payment_method_full_payment');
        $data['entry_ckassa_payment_method_partial_payment'] = $this->language->get('entry_ckassa_payment_method_partial_payment');
        $data['entry_ckassa_payment_method_credit'] = $this->language->get('entry_ckassa_payment_method_credit');
        $data['entry_ckassa_payment_method_credit_payment'] = $this->language->get('entry_ckassa_payment_method_credit_payment');
        $data['entry_ckassa_payment_object_commodity'] = $this->language->get('entry_ckassa_payment_object_commodity');
        $data['entry_ckassa_payment_object_excise'] = $this->language->get('entry_ckassa_payment_object_excise');
        $data['entry_ckassa_payment_object_job'] = $this->language->get('entry_ckassa_payment_object_job');
        $data['entry_ckassa_payment_object_service'] = $this->language->get('entry_ckassa_payment_object_service');
        $data['entry_ckassa_payment_object_gambling_bet'] = $this->language->get('entry_ckassa_payment_object_gambling_bet');
        $data['entry_ckassa_payment_object_gambling_prize'] = $this->language->get('entry_ckassa_payment_object_gambling_prize');
        $data['entry_ckassa_payment_object_lottery'] = $this->language->get('entry_ckassa_payment_object_lottery');
        $data['entry_ckassa_payment_object_lottery_prize'] = $this->language->get('entry_ckassa_payment_object_lottery_prize');
        $data['entry_ckassa_payment_object_intellectual_activity'] = $this->language->get('entry_ckassa_payment_object_intellectual_activity');
        $data['entry_ckassa_payment_object_payment'] = $this->language->get('entry_ckassa_payment_object_payment');
        $data['entry_ckassa_payment_object_agent_commission'] = $this->language->get('entry_ckassa_payment_object_agent_commission');
        $data['entry_ckassa_payment_object_composite'] = $this->language->get('entry_ckassa_payment_object_composite');
        $data['entry_ckassa_payment_object_another'] = $this->language->get('entry_ckassa_payment_object_another');
        $data['entry_ckassa_taxation_osn'] = $this->language->get('entry_ckassa_taxation_osn');
        $data['entry_ckassa_taxation_usn_income'] = $this->language->get('entry_ckassa_taxation_usn_income');
        $data['entry_ckassa_taxation_usn_income_outcome'] = $this->language->get('entry_ckassa_taxation_usn_income_outcome');
        $data['entry_ckassa_taxation_envd'] = $this->language->get('entry_ckassa_taxation_envd');
        $data['entry_ckassa_taxation_esn'] = $this->language->get('entry_ckassa_taxation_esn');
        $data['entry_ckassa_taxation_patent'] = $this->language->get('entry_ckassa_taxation_patent');
        $data['entry_ckassa_order_status_before_payment'] = $this->language->get('entry_ckassa_order_status_before_payment');
        $data['entry_ckassa_order_status_after_payment'] = $this->language->get('entry_ckassa_order_status_after_payment');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('payment/ckassa', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $data['action'] = $this->url->link('payment/ckassa', 'token=' . $this->session->data['token'], 'SSL');

        $data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');


        $data['token'] = $this->session->data['token'];

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('payment/ckassa.tpl', $data));
    }

    /**
     * 
     * @return array
     */
    public function defaultConfiguration() {

        $this->load->model('setting/setting');

        $serverName = $this->serverName();

        return [
            'ckassa_is_test' => $this->config->get('ckassa_is_test') ? $this->config->get('ckassa_is_test') : 0,
            'ckassa_invunic' => $this->config->get('ckassa_invunic') ? $this->config->get('ckassa_invunic') : 'SIMPLE',
            'ckassa_url' => $this->config->get('ckassa_url') ? $this->config->get('ckassa_url') : '',
            'ckassa_cb_url' => $this->config->get('ckassa_cb_url') ? $this->config->get('ckassa_cb_url') : $serverName . '/index.php?route=payment/ckassa/callback',
            'ckassa_success_url' => $this->config->get('ckassa_success_url') ? $this->config->get('ckassa_success_url') : $serverName,
            'ckassa_fail_url' => $this->config->get('ckassa_fail_url') ? $this->config->get('ckassa_fail_url') : $serverName,
            'ckassa_secret' => $this->config->get('ckassa_secret') ? $this->config->get('ckassa_secret') : '',
            'ckassa_shop_key' => $this->config->get('ckassa_shop_key') ? $this->config->get('ckassa_shop_key') : '',
            'ckassa_currency' => 'RUB', //$this->config->get('ckassa_currency') ? $this->config->get('ckassa_currency') : 'RUB',
            'ckassa_lang' => 'RU', //$this->config->get('ckassa_lang') ? $this->config->get('ckassa_lang') : 'RU',
            'ckassa_country' => $this->config->get('ckassa_country') ? $this->config->get('ckassa_country') : 'RU',
            'ckassa_taxation' => $this->config->get('ckassa_taxation') ? $this->config->get('ckassa_taxation') : 'osn',
            'ckassa_tax' => $this->config->get('ckassa_tax') ? $this->config->get('ckassa_tax') : 'none',
            'ckassa_tax_delivery' => $this->config->get('ckassa_tax_delivery') ? $this->config->get('ckassa_tax_delivery') : 'none',
            'ckassa_payment_method' => $this->config->get('ckassa_payment_method') ? $this->config->get('ckassa_payment_method') : 'full_prepayment',
            'ckassa_payment_object' => $this->config->get('ckassa_payment_object') ? $this->config->get('ckassa_payment_object') : 'commodity',
            'ckassa_order_status_before_payment' => $this->config->get('ckassa_order_status_before_payment') ? $this->config->get('ckassa_order_status_before_payment') : '',
            'ckassa_order_status_after_payment' => $this->config->get('ckassa_order_status_after_payment') ? $this->config->get('ckassa_order_status_after_payment') : '',
            'ckassa_sort_order' => $this->config->get('ckassa_sort_order') ? $this->config->get('ckassa_sort_order') : '',
        ];
    }

    function serverName() {
        $protocol = "http";
        if ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') || $_SERVER['SERVER_PORT'] == 443) {
            $protocol = "https";
        }

        return "{$protocol}://{$_SERVER['SERVER_NAME']}";
    }

    /**
     * 
     * @return array
     */
    public function prepareConfiguration() {

        $config = $this->defaultConfiguration();
//        if (isset($this->request->post['ckassa_url'])) {
//            $config['ckassa_url'] = $this->request->post['ckassa_url'];
//        }
        if (isset($this->request->post['ckassa_cb_url'])) {
            $config['ckassa_cb_url'] = $this->request->post['ckassa_cb_url'];
        }
        if (isset($this->request->post['ckassa_invunic'])) {
            $config['ckassa_invunic'] = $this->request->post['ckassa_invunic'];
        }
        if (isset($this->request->post['ckassa_success_url'])) {
            $config['ckassa_success_url'] = $this->request->post['ckassa_success_url'];
        }
        if (isset($this->request->post['ckassa_fail_url'])) {
            $config['ckassa_fail_url'] = $this->request->post['ckassa_fail_url'];
        }
        if (isset($this->request->post['ckassa_secret'])) {
            $config['ckassa_secret'] = $this->request->post['ckassa_secret'];
        }
        if (isset($this->request->post['ckassa_shop_key'])) {
            $config['ckassa_shop_key'] = $this->request->post['ckassa_shop_key'];
        }
        if (isset($this->request->post['ckassa_currency'])) {
            $config['ckassa_currency'] = $this->request->post['ckassa_currency'];
        }
        if (isset($this->request->post['ckassa_lang'])) {
            $config['ckassa_lang'] = $this->request->post['ckassa_lang'];
        }
        if (isset($this->request->post['ckassa_country'])) {
            $config['ckassa_country'] = $this->request->post['ckassa_country'];
        }
        if (isset($this->request->post['ckassa_taxation'])) {
            $config['ckassa_taxation'] = $this->request->post['ckassa_taxation'];
        }
        if (isset($this->request->post['ckassa_tax'])) {
            $config['ckassa_tax'] = $this->request->post['ckassa_tax'];
        }
        if (isset($this->request->post['ckassa_tax_delivery'])) {
            $config['ckassa_tax_delivery'] = $this->request->post['ckassa_tax_delivery'];
        }
        if (isset($this->request->post['ckassa_payment_method'])) {
            $config['ckassa_payment_method'] = $this->request->post['ckassa_payment_method'];
        }
        if (isset($this->request->post['ckassa_payment_object'])) {
            $config['ckassa_payment_object'] = $this->request->post['ckassa_payment_object'];
        }
        if (isset($this->request->post['ckassa_status'])) {
            $config['ckassa_status'] = $this->request->post['ckassa_status'];
        }
        if (isset($this->request->post['ckassa_order_status_before_payment'])) {
            $config['ckassa_order_status_before_payment'] = $this->request->post['ckassa_order_status_before_payment'];
        }
        if (isset($this->request->post['ckassa_order_status_after_payment'])) {
            $config['ckassa_order_status_after_payment'] = $this->request->post['ckassa_order_status_after_payment'];
        }
        if (isset($this->request->post['ckassa_sort_order'])) {
            $config['ckassa_sort_order'] = $this->request->post['ckassa_sort_order'];
        }

        return $config;
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'payment/ckassa')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if ($this->request->post['ckassa_is_test'] != 1) {
            if (!$this->request->post['ckassa_secret']) {
                $this->error['ckassa_secret'] = $this->language->get('ckassa_secret_error');
            }

            if (!$this->request->post['ckassa_shop_key']) {
                $this->error['ckassa_shop_key'] = $this->language->get('ckassa_shop_key_error');
            }
        }


        if (!$this->error) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

}

?>
